import * as Sequelize from 'sequelize';
import Relation from '../lib/relation';
import { ctx } from '../utils/iface';
export default class Config {
    _ctx: any;
    constructor(ctx?: ctx);
    readonly AppDebug: boolean;
    readonly AppPath: string;
    sendFile: boolean;
    readonly session: SessionOptions;
    readonly dbConfig: any;
    readonly dbPrefix: string;
    readonly db: Sequelize.Sequelize;
    protected _trans: any;
    protected _transTimes: number;
    startTrans(): Promise<any>;
    commit(): Promise<boolean>;
    rollback(): Promise<boolean>;
    readonly checkProxy: boolean;
    controller(ctx: ctx): void;
    getDbDefine(TableName: string): any;
    getDbTableFields(TableName: string): string[];
    getDbTablePK(TableName: string): string;
    getRelation(RelationName: string): Relation | boolean;
    readonly StaticPath: string;
    getStaticFile(p?: string): Promise<void>;
    readonly allowCORS: boolean;
    readonly outformat: any;
}
export interface CookieOptions {
    domain?: string;
    path?: string;
    maxAge?: number;
    expires?: Date;
    httpOnly?: boolean;
    overwrite?: boolean;
}
export interface SessionOptions {
    key: string;
    domain?: string;
    path: string;
    maxAge: number;
    expires?: Date;
    httpOnly?: boolean;
    overwrite?: boolean;
    signed?: boolean;
    rolling?: boolean;
    renew?: boolean;
    store?: any;
}
