"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const errors_1 = require("../utils/errors");
const file_1 = require("../utils/file");
const db_1 = require("../utils/db");
const controller_1 = require("../utils/controller");
const fs_1 = require("fs");
const mime = require("mime");
const path = require("path");
class basecontroller {
    constructor(ctx) {
        this._ModelName = "";
        this._ctx = ctx;
        this._config = ctx.config;
        this._ModelName = this.__proto__.constructor.name;
        if (!this._checkPermission(ctx)) {
            throw new Error(errors_1.default.PERMISSION_DENIED);
        }
    }
    get _KeywordFields() { return []; }
    ;
    get _KeywordTable() { return ''; }
    ;
    get _WFields() { return []; }
    ;
    get _saveFields() {
        return {};
    }
    get _searchFields() {
        return this._config.getDbTableFields(this._ModelName);
    }
    get _WTable() { return ''; }
    ;
    get _pk() {
        return this._ctx.config.getDbTablePK(this._ModelName);
    }
    get _model() {
        if (this._ctx.config.getDbDefine(this._ModelName))
            return db_1.M(this._ctx, this._ModelName);
    }
    async _checkPermission(ctx) {
        return true;
    }
    async _send(path, filename) {
        this._ctx.attachment(filename);
        this._ctx.config.sendFile = true;
        this._ctx.body = fs_1.createReadStream(path);
    }
    _sendContent(content, filename) {
        this._ctx.attachment(filename);
        this._ctx.config.sendFile = true;
        this._ctx.body = content;
    }
    _cookie(name, value, options) {
        if ('undefined' == typeof value) {
            try {
                return this._ctx.cookies.get(name);
            }
            catch (e) {
                return '';
            }
        }
        else {
            this._ctx.cookies.set(name, value, options ? options : {});
        }
    }
    _session(name, value) {
        try {
            if ('undefined' == typeof value) {
                return this._ctx.session.get(name);
            }
            else if (name === null) {
                this._ctx.session.destory();
            }
            else {
                this._ctx.session.set(name, value);
            }
        }
        catch (e) {
            return '';
        }
    }
    async _sendFile(file, ext = '', config = {}) {
        if (await file_1.filesystem.exist(file)) {
            let stat = await file_1.filesystem.stat(file);
            this._ctx.set('Content-Type', mime.getType(ext ? ext : path.parse(file).ext.substr(1)));
            this._ctx.set('Content-Length', stat.size);
            this._ctx.set('Last-Modified', stat.mtimeMs);
            this._ctx.set('Cache-Control', 'public');
            this._ctx.body = fs_1.createReadStream(file);
        }
    }
    get _files() {
        if (this._ctx.req.files) {
            return this._ctx.req.files;
        }
        throw new Error(errors_1.default.NO_UPLOAD_FILES);
    }
    M(TableName) {
        let modal = db_1.M(this._ctx, TableName ? TableName : this._ModelName);
        if (this.trans) {
            modal.setTrans(this.trans);
        }
        return modal;
    }
    async startTrans() {
        this.trans = await this._ctx.config.startTrans();
        return this.trans;
    }
    async commit() {
        return await this._ctx.config.commit();
    }
    async rollback() {
        return await this._ctx.config.rollback();
    }
    R(RelationName) {
        return db_1.R(this._ctx, RelationName ? RelationName : this._ModelName);
    }
    I(Name, options) {
        return controller_1.I(this._ctx, Name, options);
    }
}
exports.default = basecontroller;
//# sourceMappingURL=basecontroller.js.map