"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_1 = require("lodash");
const db_1 = require("../utils/db");
const basecontroller_1 = require("./basecontroller");
class Controller extends basecontroller_1.default {
    async search(post) {
        let W = this.I('W', { d: {}, type: 'object' }), Keyword = this.I('Keyword', { d: '', type: 'string' }), KeywordFields = this.I('KF', { d: [], type: 'array' }), P = this.I('P', { d: 1, type: 'number' }), N = this.I('N', { d: 10, type: 'number' }), Sort = this.I('Sort', { d: '', type: 'string' }), WPKIDs = [], PKIDs = [], KeywordIDs = [];
        if (Keyword.length > 0) {
            let Where = {};
            let Fields = lodash_1.uniq([...KeywordFields, ...this._KeywordFields]);
            if (Fields) {
                Fields.forEach((v) => {
                    Where[v] = { like: `%${Keyword.replace(/[ ;%\r\n]/g, '')}%` };
                });
                if (this._KeywordTable) {
                    KeywordIDs = await db_1.M(this._ctx, this._KeywordTable).where({ or: Where }).getFields(this._ctx.config.getDbTablePK(this._ModelName), true);
                }
            }
        }
        if (Object.keys(W).length > 0) {
        }
        let ModelName = this._WTable ? this._WTable : this._ModelName;
        let CurrentModel = db_1.M(this._ctx, ModelName);
        WPKIDs = await CurrentModel.where(W).order(Sort).getFields(this._ctx.config.getDbTablePK(ModelName), true);
        if (Keyword) {
            PKIDs = lodash_1.intersection(WPKIDs, KeywordIDs);
        }
        else {
            PKIDs = WPKIDs;
        }
        let T = PKIDs.length;
        if (PKIDs.length > (P - 1) * N) {
            PKIDs = PKIDs.slice((P - 1) * N, P * N);
        }
        else {
            PKIDs = [];
        }
        return {
            L: PKIDs.length > 0 ? await db_1.R(this._ctx, ModelName).order(Sort).fields(Object.keys(this._searchFields)).objects(PKIDs) : [],
            T,
            P, N, R: {}
        };
    }
    async add(post, ctx) {
        return await this._model.add(post);
    }
    async del(post, ctx) {
        return await this._model.where({ [this._ctx.config.getDbTablePK(this._ModelName)]: this.I(this._ctx.config.getDbTablePK(this._ModelName), { type: 'number' }) }).del();
    }
    async save(post, ctx) {
        return await this._model
            .where({ [this._ctx.config.getDbTablePK(this._ModelName)]: this.I(this._ctx.config.getDbTablePK(this._ModelName), { type: 'number' }) })
            .save(this.I('Params', {
            type: (data) => {
                lodash_1.forOwn(this._saveFields, (v, k) => {
                    if (v instanceof Function) {
                        v(k, data);
                    }
                    else {
                    }
                });
                return true;
            }
        }));
    }
    async saveW(post, ctx) {
        let W = this.I('W', { type: 'object' });
        if (W)
            return await this._model.where(this.I('W', { type: 'object' })).save(this.I('Params', { type: 'object' }));
        return false;
    }
    async delW(post, ctx) {
        let W = this.I('W', { type: 'object' });
        if (W)
            return await this._model.where(W).del();
        else
            return false;
    }
    async adds(post, ctx) {
        return await this._model.addAll(Object.values(post));
    }
    async replaceW(post, ctx) {
        await this._model.where(this.I('W', { type: 'object', d: { [this._pk]: 0 } })).del();
        return await this._model.addAll(this.I('Data'));
    }
}
exports.default = Controller;
//# sourceMappingURL=controller.js.map