"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _ = require("lodash");
const db_1 = require("../utils/db");
const array_1 = require("../utils/array");
const errors_1 = require("../utils/errors");
class RelationConfiger {
    constructor(config) {
        this.name = '';
        this.table = '';
        this.fields = [];
        this.pk = '';
        this.fk = '';
        this.relation = false;
        this.where = undefined;
        this.order = '';
        if (config) {
            if (config.name)
                this.name = config.name;
            if (config.table)
                this.table = config.table;
            if (config.fields) {
                if ('string' == typeof config.fields) {
                    this.fields = config.fields.split(',');
                }
                else {
                    this.fields = config.fields;
                }
            }
            if (config.pk)
                this.pk = config.pk;
            this.fk = config.fk ? config.fk : config.pk;
            this.relation = config.relation ? config.relation : false;
            this.where = config.where ? config.where : undefined;
        }
    }
}
exports.RelationConfiger = RelationConfiger;
class Relation {
    constructor(ctx, Table, Fields = "", PK = "") {
        this._one = {};
        this._many = {};
        this._extend = {};
        this._table = "";
        this._pk = "";
        this._fields = [];
        this._foreach = [];
        this._ctx = {};
        this._table = Table;
        this._ctx = ctx;
        let _fields = [];
        if (Fields instanceof String) {
            _fields = Fields.split(',');
        }
        if (Fields.length == 0) {
            _fields = this._ctx.config.getDbTableFields(Table);
        }
        if (PK.length === 0) {
            PK = this._ctx.config.getDbTablePK(Table);
        }
        this._fields = _fields;
        this._pk = PK;
        this._model = db_1.M(ctx, Table);
    }
    config(Table, Fields, PK) {
        this._table = Table;
        this._fields = Fields;
        this._pk = PK;
        if (Table)
            this._model = db_1.M(this._ctx, Table);
    }
    hasOne(config) {
        if (_.isString(config.name) && config.name.length > 0) {
            this.One = config;
        }
        return this;
    }
    get One() {
        return this._one;
    }
    set One(config) {
        if (_.isString(config.name) && config.name.length > 0) {
            this._one[config.name] = new RelationConfiger(config);
        }
    }
    hasMany(config) {
        this.Many = config;
        return this;
    }
    get Many() {
        return this._many;
    }
    set Many(config) {
        if (_.isString(config.name) && config.name.length > 0) {
            this._many[config.name] = new RelationConfiger(config);
        }
    }
    extend(config) {
        if (_.isString(config.name) && config.name.length > 0) {
            this.Extend = config;
        }
        return this;
    }
    get Extend() {
        return this._extend;
    }
    set Extend(config) {
        if (_.isString(config.name) && config.name.length > 0) {
            this._extend[config.name] = new RelationConfiger(config);
        }
    }
    eval(w) {
        if (w instanceof Function) {
            return w(this._ctx);
        }
        else {
            return w;
        }
    }
    async objects(PKValues) {
        if (PKValues instanceof Array) {
            let data = await this._model.fields(this._fields).where({
                [this._pk]: { 'in': PKValues }
            }).select();
            let Qs = [data];
            if (data instanceof Array) {
                _.forOwn(this.One, (v, k) => {
                    if (v instanceof Function) {
                        try {
                            v = v(data);
                        }
                        catch (error) {
                        }
                    }
                    if (v.relation instanceof Relation) {
                        Qs.push(v.relation.fields(this.eval(v.fields)).order(this.eval(v.order)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                    else if (!_.isString(v.relation)) {
                        Qs.push(db_1.M(this._ctx, v.table).order(this.eval(v.order)).fields(this.eval(v.fields)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                    else {
                        let r = db_1.R(this._ctx, v.relation);
                        if (r instanceof Relation)
                            Qs.push(r.fields(this.eval(v.fields)).order(this.eval(v.order)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                });
                _.forOwn(this.Many, (v, k) => {
                    if (v instanceof Function) {
                        try {
                            v = v(data);
                        }
                        catch (error) {
                        }
                    }
                    if (v.relation instanceof Relation) {
                        Qs.push(v.relation.fields(this.eval(v.fields)).order(this.eval(v.order)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                    else if (!_.isString(v.relation)) {
                        Qs.push(db_1.M(this._ctx, v.table).order(this.eval(v.order)).fields(this.eval(v.fields)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                    else {
                        let r = db_1.R(this._ctx, v.relation);
                        if (r instanceof Relation)
                            Qs.push(r.fields(this.eval(v.fields)).order(this.eval(v.order)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                });
                _.forOwn(this.Extend, (v, k) => {
                    if (v instanceof Function) {
                        try {
                            v = v(data);
                        }
                        catch (error) {
                        }
                    }
                    if (v.relation instanceof Relation) {
                        Qs.push(v.relation.fields(this.eval(v.fields)).order(this.eval(v.order)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                    else if (!_.isString(v.relation)) {
                        Qs.push(db_1.M(this._ctx, v.table).order(this.eval(v.order)).fields(this.eval(v.fields)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                    else {
                        let r = db_1.R(this._ctx, v.relation);
                        if (r instanceof Relation)
                            Qs.push(r.fields(this.eval(v.fields)).order(this.eval(v.order)).where(this.eval(v.where)).where({ [v.fk ? v.fk : v.pk]: { 'in': array_1.array_columns(data, v.pk, true) } }).select());
                    }
                });
            }
            let result = await Promise.all(Qs);
            let i = 1, datae = result[0], one = {}, many = {}, extend = {}, config = {};
            _.forOwn(this._one, (v, k) => {
                one[v.name] = { values: result[i], config: v };
                i++;
            });
            _.forOwn(this._many, (v, k) => {
                many[v.name] = { values: result[i], config: v };
                i++;
            });
            _.forOwn(this._extend, (v, k) => {
                extend[v.name] = { values: result[i], config: v };
                i++;
            });
            _.forOwn(datae, (v, k) => {
                _.forOwn(one, (d, f) => {
                    let s = _.filter(d.values, { [d.config.fk]: datae[k][d.config.pk] });
                    datae[k][f] = s.length > 0 ? s[0] : {};
                });
                _.forOwn(many, (d, f) => {
                    let s = _.filter(d.values, { [d.config.fk]: datae[k][d.config.pk] });
                    datae[k][f] = s.length > 0 ? s : [];
                });
                _.forOwn(extend, (d, f) => {
                    let s = _.filter(d.values, { [d.config.fk]: datae[k][d.config.pk] });
                    datae[k] = _.assign(v, s.length > 0 ? s[0] : {});
                });
                _.forOwn(this._foreach, (f, k) => {
                    if (_.isFunction(f)) {
                        f.apply(this, [datae[k]]);
                    }
                });
            });
            return datae;
        }
        else {
            throw new Error(errors_1.default.RELATION_OBJECTS_VALUE_NOT_ARRAY);
        }
    }
    data_columns(arr, column) {
        let a = [];
        _.forOwn(arr, (v, k) => {
            a.push(v.dataValues[column]);
        });
        return a;
    }
    dataValues(arr, column = false) {
        let a = [];
        _.forOwn(arr, (v, k) => {
            if (false == column)
                a.push(v.dataValues);
            else
                a.push(v.dataValues[column]);
        });
        return a;
    }
    where(where) {
        this._model.where(where);
        return this;
    }
    load(DbConfig = null) {
        var conf = {};
        if (DbConfig instanceof String) {
            conf = require(`${this._ctx.config.MODEL_PATH}/${DbConfig}`);
        }
        else if (_.isObject(DbConfig)) {
        }
    }
    fields(fields) {
        this._fields = fields;
        return this;
    }
    async selectAndCount() {
        let d = await this._model.fields([this._pk]).selectAndCount();
        if (d.rows.length == 0) {
            return [[], 0];
        }
        var PKs = array_1.array_columns(d.rows, this._pk);
        return Promise.all([
            this.objects(PKs),
            d.count
        ]);
    }
    order(order) {
        this._model.order(order);
        return this;
    }
    async save(data) {
        return await this._model.save(data).then(c => {
            return c > -1;
        });
    }
    page(page, number) {
        this._model.page(page, number);
        return this;
    }
    async add(data) {
        return await this._model.add(data).then(d => {
            if (_.isObject(d) && d[this._pk] > 0) {
                return this.objects([d[this._pk]]).then(p => {
                    return p[0];
                });
            }
            else {
                return d;
            }
        });
    }
    async del() {
        return await this._model.del();
    }
    async select() {
        return await this._model.fields([this._pk]).select().then(d => {
            if (d instanceof Array && d.length > 0) {
                var PKs = array_1.array_columns(d, this._pk);
                return this.objects(PKs);
            }
            else {
                return [];
            }
        });
    }
    async find() {
        return await this._model.getFields(this._pk).then(d => {
            if (_.isNumber(d) && d > 0) {
                return this.objects([d]).then(data => {
                    return data instanceof Array && data.length > 0 ? data[0] : {};
                });
            }
            else {
                return {};
            }
        });
    }
}
exports.default = Relation;
//# sourceMappingURL=relation.js.map