"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DataType;
(function (DataType) {
    DataType[DataType["Buffer"] = 0] = "Buffer";
    DataType[DataType["JSON"] = 1] = "JSON";
    DataType[DataType["Boolean"] = 2] = "Boolean";
    DataType[DataType["Number"] = 3] = "Number";
    DataType[DataType["String"] = 4] = "String";
})(DataType = exports.DataType || (exports.DataType = {}));
function getDataType(data) {
    if (data instanceof Buffer) {
        return DataType.Buffer;
    }
    else if ('number' == typeof data) {
        return DataType.Number;
    }
    else if ('boolean' == typeof data) {
        return DataType.Boolean;
    }
    else if ('string' == typeof data) {
        return DataType.String;
    }
    else {
        return DataType.JSON;
    }
}
exports.getDataType = getDataType;
//# sourceMappingURL=data.js.map