"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const model_1 = require("../lib/model");
const _ = require("lodash");
const relation_1 = require("../lib/relation");
const path = require("path");
function M(ctx, Table) {
    if (ctx.config.getDbDefine(Table))
        return new model_1.default(ctx, Table);
}
exports.M = M;
function R(ctx, name, force = false) {
    const Relations = {};
    if (!_.isObject(Relations[name])) {
        try {
            let rp = path.resolve(path.join(ctx.config.AppPath, 'relation', name));
            var r = require(rp).default;
            if (r) {
                Relations[name] = new r(ctx, name, ctx.config.getDbTableFields(name), ctx.config.getDbTablePK(name));
            }
            else {
                Relations[name] = new relation_1.default(ctx, name, ctx.config.getDbTableFields(name), ctx.config.getDbTablePK(name));
            }
        }
        catch (e) {
            Relations[name] = new relation_1.default(ctx, name, ctx.config.getDbTableFields(name), ctx.config.getDbTablePK(name));
        }
    }
    return Relations[name];
}
exports.R = R;
//# sourceMappingURL=db.js.map