"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chokidar = require("chokidar");
const fs = require("fs");
const path = require("path");
const url_1 = require("url");
const download = require("download");
const errors_1 = require("./errors");
var WatchType;
(function (WatchType) {
    WatchType["Add"] = "add";
    WatchType["Change"] = "change";
    WatchType["Delete"] = "unlink";
    WatchType["Unlink"] = "unlink";
    WatchType["AddDir"] = "addDir";
    WatchType["Raw"] = "raw";
})(WatchType = exports.WatchType || (exports.WatchType = {}));
function watch(Path, Type, Callback) {
    let wathcer = chokidar.watch(Path);
    Type.forEach((d) => {
        wathcer.on(d, Callback);
    });
    return wathcer;
}
exports.watch = watch;
async function read_file(path) {
    if (fs.existsSync(path)) {
        return fs.readFileSync(path);
    }
    else {
        let url = new url_1.URL(path);
        if ('http' == url.protocol.substr(0, 4)) {
            return await download(path);
        }
        else {
            throw new Error(errors_1.default.READ_FILE_PATH_ERROR);
        }
    }
}
exports.read_file = read_file;
function mkdirs(dirpath, mode = 0o777, callback = null) {
    if (fs.existsSync(dirpath)) {
        return true;
    }
    else {
        let parent_path = path.dirname(dirpath);
        if (fs.existsSync(parent_path)) {
            return fs.mkdirSync(dirpath, mode);
        }
        else {
            mkdirs(parent_path, mode);
            fs.mkdirSync(dirpath, mode);
        }
    }
}
exports.mkdirs = mkdirs;
class filesystem {
    static async exist(file) {
        return new Promise((s, j) => {
            fs.exists(file, (rs) => {
                s(rs);
            });
        });
    }
    static async stat(file) {
        return new Promise((s, j) => {
            fs.stat(file, (err, stat) => {
                if (err)
                    j(err);
                else
                    s(stat);
            });
        });
    }
}
exports.filesystem = filesystem;
//# sourceMappingURL=file.js.map