import Config from "../config";
import * as Sequelize from 'sequelize';
export interface UploadFiles {
    fieldName: string;
    name: string;
    originalFilename: string;
    path: string;
    size: number;
    type: string;
}
export declare enum HttpCode {
    NOT_FOUND = 404,
    OK = 200,
    PERMISSION_DENIED = 403,
    SERVER_ERROR = 500
}
export interface ctx {
    error: any;
    config: Config;
    path: string;
    websocket?: any;
    set(key: string, value: string | number): any;
    get(key: string): any;
    req: {
        body: {
            [index: string]: any;
        };
        files: {
            [index: string]: UploadFiles;
        };
    };
    method: string;
    request: {
        body: any;
        query: {
            [index: string]: string;
        };
    };
    control: {
        m: string;
        c: string;
    };
    attachment(filename: string): any;
    redirect(w: string, h?: string): any;
    header: {
        [index: string]: string;
    };
    headers: {
        [index: string]: string;
    };
    hostname: string;
    body: any;
    cookies: {
        set: (name: string, value: any, options?: any) => {};
        get: (name: string) => string;
    };
    session: any;
    status: number;
    query: {
        [index: string]: string;
    };
}
export declare const DbDataType: {
    char: Sequelize.DataTypeChar;
    varchar: Sequelize.DataTypeString;
    double: Sequelize.DataTypeDouble;
    float: Sequelize.DataTypeFloat;
    text: Sequelize.DataTypeText;
    smallint: Sequelize.DataTypeSmallInt;
    tinyint: Sequelize.DataTypeTinyInt;
    mediumint: Sequelize.DataTypeMediumInt;
    int: Sequelize.DataTypeInteger;
    bigint: Sequelize.DataTypeBigInt;
    decimal: Sequelize.DataTypeDecimal;
    boolean: Sequelize.DataTypeBoolean;
    enum: Sequelize.DataTypeEnum;
    datetime: Sequelize.DataTypeDate;
    timestamp: Sequelize.DataTypeTime;
};
export declare const DbOp: {
    eq: symbol;
    ne: symbol;
    gte: symbol;
    gt: symbol;
    lte: symbol;
    lt: symbol;
    not: symbol;
    is: symbol;
    in: symbol;
    notIn: symbol;
    like: symbol;
    notLike: symbol;
    iLike: symbol;
    notILike: symbol;
    regexp: symbol;
    notRegexp: symbol;
    iRegexp: symbol;
    notIRegexp: symbol;
    between: symbol;
    notBetween: symbol;
    overlap: symbol;
    contains: symbol;
    contained: symbol;
    adjacent: symbol;
    strictLeft: symbol;
    strictRight: symbol;
    noExtendRight: symbol;
    noExtendLeft: symbol;
    and: symbol;
    or: symbol;
    any: symbol;
    all: symbol;
    values: symbol;
    col: symbol;
    placeholder: symbol;
    join: symbol;
};
