"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const Sequelize = require("sequelize");
var HttpCode;
(function (HttpCode) {
    HttpCode[HttpCode["NOT_FOUND"] = 404] = "NOT_FOUND";
    HttpCode[HttpCode["OK"] = 200] = "OK";
    HttpCode[HttpCode["PERMISSION_DENIED"] = 403] = "PERMISSION_DENIED";
    HttpCode[HttpCode["SERVER_ERROR"] = 500] = "SERVER_ERROR";
})(HttpCode = exports.HttpCode || (exports.HttpCode = {}));
exports.DbDataType = {
    char: Sequelize.CHAR,
    varchar: Sequelize.STRING,
    double: Sequelize["DOUBLE PRECISION"],
    float: Sequelize.FLOAT,
    text: Sequelize.TEXT,
    smallint: Sequelize.SMALLINT,
    tinyint: Sequelize.TINYINT,
    mediumint: Sequelize.MEDIUMINT,
    int: Sequelize.INTEGER,
    bigint: Sequelize.BIGINT,
    decimal: Sequelize.DECIMAL,
    boolean: Sequelize.BOOLEAN,
    enum: Sequelize.ENUM,
    datetime: Sequelize.DATE,
    timestamp: Sequelize.TIME,
};
exports.DbOp = {
    eq: Sequelize.Op.eq,
    ne: Sequelize.Op.ne,
    gte: Sequelize.Op.gte,
    gt: Sequelize.Op.gt,
    lte: Sequelize.Op.lte,
    lt: Sequelize.Op.lt,
    not: Sequelize.Op.not,
    is: Sequelize.Op.is,
    in: Sequelize.Op.in,
    notIn: Sequelize.Op.notIn,
    like: Sequelize.Op.like,
    notLike: Sequelize.Op.notLike,
    iLike: Sequelize.Op.iLike,
    notILike: Sequelize.Op.notILike,
    regexp: Sequelize.Op.regexp,
    notRegexp: Sequelize.Op.notRegexp,
    iRegexp: Sequelize.Op.iRegexp,
    notIRegexp: Sequelize.Op.notIRegexp,
    between: Sequelize.Op.between,
    notBetween: Sequelize.Op.notBetween,
    overlap: Sequelize.Op.overlap,
    contains: Sequelize.Op.contains,
    contained: Sequelize.Op.contained,
    adjacent: Sequelize.Op.adjacent,
    strictLeft: Sequelize.Op.strictLeft,
    strictRight: Sequelize.Op.strictRight,
    noExtendRight: Sequelize.Op.noExtendRight,
    noExtendLeft: Sequelize.Op.noExtendLeft,
    and: Sequelize.Op.and,
    or: Sequelize.Op.or,
    any: Sequelize.Op.any,
    all: Sequelize.Op.all,
    values: Sequelize.Op.values,
    col: Sequelize.Op.col,
    placeholder: Sequelize.Op.placeholder,
    join: Sequelize.Op.join
};
//# sourceMappingURL=iface.js.map