"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path = require("path");
const errors_1 = require("./errors");
async function controller(Class, Method, ctx) {
    let ClassObject = await get_controller(Class, ctx.config);
    if (ClassObject instanceof Function) {
        let d = {};
        let c = new ClassObject(ctx);
        if (c['_before_' + Method] instanceof Function) {
            await c['_before_' + Method](ctx.req.body, ctx);
        }
        if (c[Method] instanceof Function) {
            d = await c[Method](ctx.req.body, ctx);
        }
        else if (c['__call'] instanceof Function) {
            d = await c['__call'](ctx.req.body, ctx);
        }
        if (c['_after_' + Method] instanceof Function) {
            d = await c['_after_' + Method](d, ctx.req.body, ctx);
        }
        return d;
    }
    else {
        throw new Error(errors_1.default.METHOD_NOT_FOUND);
    }
}
exports.controller = controller;
async function get_controller(Class, Config) {
    let cp = path.resolve(path.join(Config.AppPath, 'controller', Class));
    return require(`${cp}.js`).default;
}
exports.get_controller = get_controller;
//# sourceMappingURL=service.js.map