"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = require("castle-rpc-server/dist/index");
const service_1 = require("./service");
class RPCService extends index_1.RPCServer {
    constructor() {
        super({});
    }
    async controller(path, data, rpc, ctx) {
        let p = path.split('/');
        if (p.length > 1) {
            if (p[0] == "" && p.length > 2) {
                p.shift();
            }
            ctx.control = {
                c: p[0],
                m: p.length == 1 ? 'index' : p[1],
            };
        }
        else {
            throw 'ErrorPath';
        }
        ctx.req.body = data;
        return await service_1.controller(ctx.control.c, ctx.control.m, Object.assign(ctx));
    }
    async send(content, ctx) {
        if ('object' == typeof content) {
            if (ctx.RPCEncoding != 'text' && content['encode'] instanceof Function) {
                content = content['encode']();
            }
            else {
                content = JSON.stringify(content);
            }
        }
        return ctx.websocket.send(content);
    }
    async sendTo(ID, Content, ctx) {
        try {
            if (this.clients[ID] && this.clients[ID].options && this.clients[ID].options.websocket) {
                return this.send(Content, this.clients[ID].options);
            }
            else {
                throw index_1.ServerError.NOT_ONLINE;
            }
        }
        catch (error) {
            return false;
        }
    }
    get onlines() {
        return this.clients;
    }
}
exports.RPC = new RPCService();
//# sourceMappingURL=ws.js.map